# -*- coding: utf-8 -*-
import hashlib
# hashlib module is a popular module to do hashing in python

#Конструкторы md5(), sha1(), sha224(), sha256(), sha384() and sha512() представленных в hashlib
md=hashlib.md5()
md.update("The quick brown fox jumps over the lazy dog")
print md.digest()
print "Digest Size:", md.digest_size, "\n", "Block Size: ", md.block_size

# Сравнение дайджестов SHA224, SHA256,SHA384,SHA512
print "Digest SHA224", hashlib.sha224("The quick brown fox jumps over the lazy dog").hexdigest()
print "Digest SHA256", hashlib.sha256("The quick brown fox jumps over the lazy dog").hexdigest()
print "Digest SHA384", hashlib.sha384("The quick brown fox jumps over the lazy dog").hexdigest()
print "Digest SHA512", hashlib.sha512("The quick brown fox jumps over the lazy dog").hexdigest()
# Все дайджесты уникальные

# Пример 160-битового хэша RIPEMD160
h = hashlib.new('ripemd160')
h.update("The quick brown fox jumps over the lazy dog")
h.hexdigest()

#Алгоритм генерации ключей
#Исходный алгоритм хэширования уязвим к атаке перебором
#Алгоритм генерации ключей доработан для повышения защищенности
import hashlib, binascii
algorithm='sha256'
password='HomeWifi'
salt='salt' # salt это случайные данные, которые добавляются в одностороннюю функцию
nu_rounds=1000
key_length=64 #dklen это длина генерируемого ключа
dk = hashlib.pbkdf2_hmac(algorithm,password, salt, nu_rounds, dklen=key_length)
print 'derived key: ',dk
print 'derived key in hexadeximal :', binascii.hexlify(dk)

#Пример хэширования
import hashlib

input = "Sample Input Text"
for i in xrange(20):
	# добавляем итератор к исходному тексту
	input_text = input + str(i)
	# печатаем входное сообщение и его хэш
	print input_text, ':', hashlib.sha256(input_text).
	hexdigest()