# -*- coding: utf-8 -*-

from hashlib import sha256

class MerkleTree(object):
	def __init__(self):
		pass
		
	def chunks(self,transaction,n):
	#Эта функция генерирует количество n транзакций за раз
	for i in range (0, len(transaction),number):
		yield transaction[i:i+2]
		
	def merkle_tree(self,transactions):
	#Здесь мы находим хэш дерева Меркла для всех
	#транзакций, переданных в эту функцию
	#Задача решается применением рекурсии
	#Берем список транзакций, объединяем их по две,
	#вычисляем хэш группы, храним этот хэш.
	#Затем снова группируем попарно, снова вычисляем
	#хэш пары, и так до тех пор, пока не останется один хэш.
	sub_tree=[]
	for i in chunks(transactions,2):
		if len(i)==2:
			hash = sha256(str(i[0]+i[1])).hexdigest()
		else:
			hash = sha256(str(i[0]+i[0])).hexdigest()
		sub_tree.append(hash)
	#Если поддерево содержит только один хэш,
	#значит мы достигли корня дерева.
	#В противном случае рекурсивно вызываем функцию
	if len(sub_tree) == 1:
		return sub_tree[0]
	else:
		return self.merkle_tree(sub_tree)
		
if __name__=='__main__':
	mk=MerkleTree()
	merkle_hash= mk.merkle_tree(["TX1","TX2","TX3","TX4","TX5","TX6"])
	print merkle_hash